<template>
<div>
    <app-layout>
        <template #header>User Management</template>
        <div class="grid gap-2 justify-around lg:grid-cols-3">
            <searchable-data-card 
                v-if="hasPermission(['read-anything','read-orgs'])"
                name="Organizations"
                type="organizations"
                :form="orgform"
                :data="organizations"
                :headers="{name:'Name',domain:'Domain'}"
                @new="newOrgModalOpen = true"
                @click="id => $inertia.get('/organizations/' + id)"
            >
                <template #info>
                    <div class="grid justify-items-center">
                        <div class="text-center">
                            Total<br>
                            <span class="text-2xl">{{ orgcounts.total }}</span>
                        </div>
                    </div>
                </template>
            </searchable-data-card>
            <searchable-data-card
                v-if="hasPermission(['read-anything','read-groups']) && $page.user.current_organization_id === null"
                name="Personal Groups"
                type="groups"
                :form="groupform"
                :data="groups"
                :headers="{name:'Name','primary_user.name':'Owner'}"
                @new="newGroupModalOpener()"
                @click="id => $inertia.get('/groups/' + id)"
            >
                <template #info>
                    <div class="grid justify-items-center">
                        <div class="text-center">
                            Total<br>
                            <span class="text-2xl">{{ groupcounts.total }}</span>
                        </div>
                    </div>
                </template>
            </searchable-data-card>
            <searchable-data-card
                v-if="hasPermission(['read-anything','read-users'])"
                name="Users"
                type="users"
                :form="userform"
                :data="users"
                :headers="{name:'Name',email:'Email'}"
                @new="newUserModalOpen = true"
                @click="id => $inertia.get('/users/' + id)"
            >
                <template #info>
                    <div class="grid grid-cols-2 gap-2 justify-items-center">
                        <div class="text-center">
                            Active<br>
                            <span class="text-2xl">{{ usercounts.active }}</span>
                        </div>
                        <div class="text-center">
                            Total<br>
                            <span class="text-2xl">{{ usercounts.total }}</span>
                        </div>
                    </div>
                </template>
            </searchable-data-card>
            <div class="flex flex-col px-2 pb-4 bg-gray-100 dark:bg-gray-950 rounded-lg dark:text-white" v-if="hasPermission(['read-anything','read-roles'])">
                <inertia-link href="/roles" class="relative mt-2 my-1 mx-2">
                    <div class="flex justify-between items-center md:justify-start md:space-x-10">
                        <div class="lg:w-0 lg:flex-1">
                            <h3 class="font-bold text-xl">Role Manager</h3>
                        </div>
                        <div class="pr-1 py-1 leading-6 text-gray-600 dark:text-gray-400 hover:text-gray-500 transition ease-in-out duration-150">
                            <feather type="settings" />
                        </div>
                    </div>
                </inertia-link>
                <div class="grid grid-cols-3 gap-2 justify-items-center">
                    <div class="text-center">
                        Site<br>
                        <span class="text-2xl">{{ rolecounts.site }}</span>
                    </div>
                    <div class="text-center">
                        General<br>
                        <span class="text-2xl">{{ rolecounts.groups }}</span>
                    </div>
                    <div class="text-center">
                        Group<br>
                        <span class="text-2xl">{{ rolecounts.group }}</span>
                    </div>
                </div>
            </div>
        </div>
    </app-layout>
    <dialog-modal :show="newOrgModalOpen" @close="newOrgModalOpen = false">
        <template #title>New Organization</template>
        <div class="mb-4">
            <x-label class="mb-2">Name</x-label>
            <x-input v-model="orgform.name" placeholder="My Organization" class="w-full py-2 px-3"/>
        </div>
        <div class="mb-4">
            <x-label class="mb-2">Domain</x-label>
            <x-input v-model="orgform.domain" placeholder="example.org" class="w-full py-2 px-3"/>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="newOrgModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="createOrg">Create</x-button>
        </template>
    </dialog-modal>
    <dialog-modal :show="newGroupModalOpen" @close="newGroupModalOpen = false">
        <template #title>New Group</template>
        <div class="mb-4">
            <x-label class=" mb-2">Name</x-label>
            <x-input v-model="groupform.name" placeholder="My Group" class="w-full py-2 px-3"/>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="newGroupModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="createGroup">Create</x-button>
        </template>
    </dialog-modal>
    <dialog-modal :show="newUserModalOpen" @close="newUserModalOpen = false">
        <template #title>New User</template>
        <div class="mb-4">
            <x-label class="mb-2">Name</x-label>
            <x-input v-model="userform.name" placeholder="Name" class="w-full py-2 px-3"/>
        </div>
        <div class="mb-4">
            <x-label class="mb-2">Email</x-label>
            <x-input v-model="userform.email" placeholder="example@example.org" class="w-full py-2 px-3"/>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="newUserModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="createUser">Create</x-button>
        </template>
    </dialog-modal>
</div>
</template>

<script>
import SearchableDataCard from './../../Components/SearchableDataCard';

export default {
    components: {
        SearchableDataCard,
    },
    data(){
        return {
            orgform: this.$inertia.form({
                name: this.name,
                domain: this.domain,
                organization: true,
            }, {
                bag: 'newOrganization',
                resetOnSuccess: true,
            }),
            groupform: this.$inertia.form({
                name: this.name,
                organization: false,
            }, {
                bag: 'newGroup',
                resetOnSuccess: true,
            }),
            userform: this.$inertia.form({
                name: this.name,
                email: this.email,
            }, {
                bag: 'newUser',
                resetOnSuccess: true,
            }),
            newOrgModalOpen: false,
            newGroupModalOpen: false,
            newUserModalOpen: false,
            userList: this.users,
            userSearching:false,
            groupList: this.groups,
            organizationList: this.organizations,
        }
    },
    props: {
        users: {
            type: Array,
            default: [],
        },
        groups: {
            type: Array,
            default: [],
        },
        organizations: {
            type: Array,
            default: [],
        },
        rolecounts: Object,
        usercounts: Object,
        groupcounts: Object,
        orgcounts: Object,
    },
    methods: {
        newGroupModalOpener(id = null){
            this.newGroupModalOpen = true;
            this.groupform.parent = id;
        },
        createOrg(){
            // need to use intertia to submit
            this.newOrgModalOpen = false;
            this.orgform.post('/organizations',{
                preserveScroll: true,
            });
        },
        createGroup(){
            this.newGroupModalOpen = false;
            this.groupform.post('/groups',{
                preserveScroll: true,
            });
        },
        createUser(){
            this.newUserModalOpen = false;
            this.userform.post('/users',{
                preserveScroll: true,
            });
        },
    },
}
</script>
